module ldc.gccbuiltins_amdgcn; 

import core.simd;

nothrow @nogc:

pragma(LDC_intrinsic, "llvm.amdgcn.alignbit")
    int __builtin_amdgcn_alignbit(int, int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.alignbyte")
    int __builtin_amdgcn_alignbyte(int, int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.buffer.wbinvl1")
    void __builtin_amdgcn_buffer_wbinvl1();

pragma(LDC_intrinsic, "llvm.amdgcn.buffer.wbinvl1.sc")
    void __builtin_amdgcn_buffer_wbinvl1_sc();

pragma(LDC_intrinsic, "llvm.amdgcn.buffer.wbinvl1.vol")
    void __builtin_amdgcn_buffer_wbinvl1_vol();

pragma(LDC_intrinsic, "llvm.amdgcn.cubeid")
    float __builtin_amdgcn_cubeid(float, float, float) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.cubema")
    float __builtin_amdgcn_cubema(float, float, float) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.cubesc")
    float __builtin_amdgcn_cubesc(float, float, float) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.cubetc")
    float __builtin_amdgcn_cubetc(float, float, float) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.cvt.pk.i16")
    short2 __builtin_amdgcn_cvt_pk_i16(int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.cvt.pk.u16")
    short2 __builtin_amdgcn_cvt_pk_u16(int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.cvt.pk.u8.f32")
    int __builtin_amdgcn_cvt_pk_u8_f32(float, int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.cvt.pknorm.i16")
    short2 __builtin_amdgcn_cvt_pknorm_i16(float, float) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.cvt.pknorm.u16")
    short2 __builtin_amdgcn_cvt_pknorm_u16(float, float) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.dispatch.id")
    long __builtin_amdgcn_dispatch_id() pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.dispatch.ptr")
    void* __builtin_amdgcn_dispatch_ptr() pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.ds.bpermute")
    int __builtin_amdgcn_ds_bpermute(int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.ds.gws.barrier")
    void __builtin_amdgcn_ds_gws_barrier(int, int);

pragma(LDC_intrinsic, "llvm.amdgcn.ds.gws.init")
    void __builtin_amdgcn_ds_gws_init(int, int);

pragma(LDC_intrinsic, "llvm.amdgcn.ds.gws.sema.br")
    void __builtin_amdgcn_ds_gws_sema_br(int, int);

pragma(LDC_intrinsic, "llvm.amdgcn.ds.gws.sema.p")
    void __builtin_amdgcn_ds_gws_sema_p(int);

pragma(LDC_intrinsic, "llvm.amdgcn.ds.gws.sema.release.all")
    void __builtin_amdgcn_ds_gws_sema_release_all(int);

pragma(LDC_intrinsic, "llvm.amdgcn.ds.gws.sema.v")
    void __builtin_amdgcn_ds_gws_sema_v(int);

pragma(LDC_intrinsic, "llvm.amdgcn.ds.permute")
    int __builtin_amdgcn_ds_permute(int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.ds.swizzle")
    int __builtin_amdgcn_ds_swizzle(int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.fmul.legacy")
    float __builtin_amdgcn_fmul_legacy(float, float) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.groupstaticsize")
    int __builtin_amdgcn_groupstaticsize() pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.implicit.buffer.ptr")
    void* __builtin_amdgcn_implicit_buffer_ptr() pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.implicitarg.ptr")
    void* __builtin_amdgcn_implicitarg_ptr() pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.interp.mov")
    float __builtin_amdgcn_interp_mov(int, int, int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.interp.p1")
    float __builtin_amdgcn_interp_p1(float, int, int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.interp.p2")
    float __builtin_amdgcn_interp_p2(float, float, int, int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.kernarg.segment.ptr")
    void* __builtin_amdgcn_kernarg_segment_ptr() pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.lerp")
    int __builtin_amdgcn_lerp(int, int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.mbcnt.hi")
    int __builtin_amdgcn_mbcnt_hi(int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.mbcnt.lo")
    int __builtin_amdgcn_mbcnt_lo(int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.mqsad.pk.u16.u8")
    long __builtin_amdgcn_mqsad_pk_u16_u8(long, int, long) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.mqsad.u32.u8")
    int4 __builtin_amdgcn_mqsad_u32_u8(long, int, int4) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.msad.u8")
    int __builtin_amdgcn_msad_u8(int, int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.qsad.pk.u16.u8")
    long __builtin_amdgcn_qsad_pk_u16_u8(long, int, long) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.queue.ptr")
    void* __builtin_amdgcn_queue_ptr() pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.rcp.legacy")
    float __builtin_amdgcn_rcp_legacy(float) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.readfirstlane")
    int __builtin_amdgcn_readfirstlane(int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.readlane")
    int __builtin_amdgcn_readlane(int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.rsq.legacy")
    float __builtin_amdgcn_rsq_legacy(float) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.s.barrier")
    void __builtin_amdgcn_s_barrier() pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.s.dcache.inv")
    void __builtin_amdgcn_s_dcache_inv();

pragma(LDC_intrinsic, "llvm.amdgcn.s.dcache.inv.vol")
    void __builtin_amdgcn_s_dcache_inv_vol();

pragma(LDC_intrinsic, "llvm.amdgcn.s.dcache.wb")
    void __builtin_amdgcn_s_dcache_wb();

pragma(LDC_intrinsic, "llvm.amdgcn.s.dcache.wb.vol")
    void __builtin_amdgcn_s_dcache_wb_vol();

pragma(LDC_intrinsic, "llvm.amdgcn.s.decperflevel")
    void __builtin_amdgcn_s_decperflevel(int);

pragma(LDC_intrinsic, "llvm.amdgcn.s.get.waveid.in.workgroup")
    int __builtin_amdgcn_s_get_waveid_in_workgroup();

pragma(LDC_intrinsic, "llvm.amdgcn.s.getpc")
    long __builtin_amdgcn_s_getpc() pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.s.getreg")
    int __builtin_amdgcn_s_getreg(int);

pragma(LDC_intrinsic, "llvm.amdgcn.s.incperflevel")
    void __builtin_amdgcn_s_incperflevel(int);

pragma(LDC_intrinsic, "llvm.amdgcn.s.memrealtime")
    long __builtin_amdgcn_s_memrealtime();

pragma(LDC_intrinsic, "llvm.amdgcn.s.memtime")
    long __builtin_amdgcn_s_memtime();

pragma(LDC_intrinsic, "llvm.amdgcn.s.sendmsg")
    void __builtin_amdgcn_s_sendmsg(int, int);

pragma(LDC_intrinsic, "llvm.amdgcn.s.sendmsghalt")
    void __builtin_amdgcn_s_sendmsghalt(int, int);

pragma(LDC_intrinsic, "llvm.amdgcn.s.sleep")
    void __builtin_amdgcn_s_sleep(int);

pragma(LDC_intrinsic, "llvm.amdgcn.s.waitcnt")
    void __builtin_amdgcn_s_waitcnt(int);

pragma(LDC_intrinsic, "llvm.amdgcn.sad.hi.u8")
    int __builtin_amdgcn_sad_hi_u8(int, int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.sad.u16")
    int __builtin_amdgcn_sad_u16(int, int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.sad.u8")
    int __builtin_amdgcn_sad_u8(int, int, int) pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.wave.barrier")
    void __builtin_amdgcn_wave_barrier();

pragma(LDC_intrinsic, "llvm.amdgcn.wavefrontsize")
    int __builtin_amdgcn_wavefrontsize() pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.workgroup.id.x")
    int __builtin_amdgcn_workgroup_id_x() pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.workgroup.id.y")
    int __builtin_amdgcn_workgroup_id_y() pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.workgroup.id.z")
    int __builtin_amdgcn_workgroup_id_z() pure @safe;

pragma(LDC_intrinsic, "llvm.amdgcn.writelane")
    int __builtin_amdgcn_writelane(int, int, int) pure @safe;

